//1057,"rej2excel.sc","Lista rejestrw (Excel)",1.04,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

// RAP_ListaRejestr
int n_rej, n_kh

#include "excel.sci"
recExcel ex

#include "rej_all_par.sci"
odczytParametrow()

#include "fkutil.sci"

//odkomentowa dla celw developerskich (dane okna i id rejestru)
//#define DEBUG

int colid
int COLID_NAZWAREJ
int COLID_ZNACZNIK
int COLID_BUFOR
int COLID_OKRES
int COLID_DATADOK
int COLID_DATAZAK // lub sprzeday
int COLID_ABC = 0 // tylko dla zakupu
int COLID_NREWID
int COLID_NRDOK
int COLID_TRESC
int COLID_KTH
int COLID_NIP
int COLID_STAWKA
int COLID_BRUTTO
int COLID_NETTO
int COLID_VAT
int COLID_UE
int COLID_USL
int COLID_RECID = 0
int COLID_DANEOKNA = 0
int COLID_KH_ULICA
int COLID_KH_NUMER
int COLID_KH_KOD
int COLID_KH_MIEJSCOWOSC

// kolorystyka Excela
#define EXST_HEADER 1
#define EXST_DATAODD 2 // nieparzyste
#define EXST_DATAEVEN 3 // parzyste

recExCellData exd

void sub exdPrep( int st )
	exd.init()
	exd.m_colorIndex = 2
	exd.m_themeColor = 5
	select case st
	case EXST_HEADER
		exd.m_tintAndShade = 0.24
		exd.m_bold = true
	case EXST_DATAODD
		exd.m_tintAndShade = 0.62
	case EXST_DATAEVEN
		exd.m_tintAndShade = 0.82
	endselect
endsub

long sub recTotal()
	int td
	long recId = getID( FS )
	long recNo = 0
	long recQ = 0
	while ( td = typDanych( recNo += 1 ) ) >= 0
		if 2 != td then
			recQ += 1
		endif
		recId = getID( NX )
	wend
	recTotal = recQ
endsub

string sRecTot = using "%l", recTotal()
int td
long recId = getID( FS )
long recNo = 0
long recQ = 0
while ( td = typDanych( recNo += 1 ) ) >= 0
	if 2 != td then
		if !ex.isInited() then
			ex.init()

			colid = 0
			ex.setColWidth( COLID_NAZWAREJ = colid += 1, 25 )
			ex.setColWidth( COLID_ZNACZNIK = colid += 1, 5 )
			ex.setColWidth( COLID_BUFOR = colid += 1, 5 )
			ex.setColWidth( COLID_OKRES = colid += 1, 5 )
			ex.setColWidth( COLID_DATADOK = colid += 1, 15 )
			ex.setColWidth( COLID_DATAZAK = colid += 1, 15 )
			if flagaZakup then ex.setColWidth( COLID_ABC = colid += 1, 5 )
			ex.setColWidth( COLID_NREWID = colid += 1, 25 )
			ex.setColWidth( COLID_NRDOK = colid += 1, 25 )
			ex.setColWidth( COLID_TRESC = colid += 1, 35 )
			ex.setColWidth( COLID_KTH = colid += 1, 35 )
			ex.setColWidth( COLID_NIP = colid += 1, 15 )
			ex.setColWidth( COLID_STAWKA = colid += 1, 10 )
			ex.setColWidth( COLID_BRUTTO = colid += 1, 15 )
			ex.setColWidth( COLID_NETTO = colid += 1, 15 )
			ex.setColWidth( COLID_VAT = colid += 1, 15 )
			ex.setColWidth( COLID_UE = colid += 1, 5 )
			ex.setColWidth( COLID_USL = colid += 1, 5 )
#ifdef DEBUG
			ex.setColWidth( COLID_RECID = colid += 1, 10 )
			ex.setColWidth( COLID_DANEOKNA = colid += 1, 50 )
#endif
			ex.setColWidth( COLID_KH_ULICA = colid += 1, 50 )
			ex.setColWidth( COLID_KH_NUMER = colid += 1, 10 )
			ex.setColWidth( COLID_KH_KOD = colid += 1, 10 )
			ex.setColWidth( COLID_KH_MIEJSCOWOSC = colid += 1, 50 )


			exdPrep( EXST_HEADER )
			ex.newRow()
		 	ex.setStringF( COLID_NAZWAREJ, "Nazwa rejestru", exd )
		 	ex.setStringF( COLID_ZNACZNIK, OPIS_ZNACZNIK, exd )
			ex.setStringF( COLID_BUFOR, opisBufor, exd )
			ex.setStringF( COLID_OKRES, opisOkres, exd )
			ex.setStringF( COLID_DATADOK, opisDataDok, exd )
			ex.setStringF( COLID_DATAZAK, opisData, exd )
			if COLID_ABC then ex.setStringF( COLID_ABC, opisABC, exd )
			ex.setStringF( COLID_NREWID, opisNrEwid, exd )
			ex.setStringF( COLID_NRDOK, opisNrDok, exd )
			ex.setStringF( COLID_TRESC, "Tre", exd )
			ex.setStringF( COLID_KTH, "Kontrahent", exd )
			ex.setStringF( COLID_NIP, "NIP", exd )
			ex.setStringF( COLID_STAWKA, OPIS_STAWKA, exd )
			ex.setStringF( COLID_BRUTTO, OPIS_BRUTTO, exd )
			ex.setStringF( COLID_NETTO, OPIS_NETTO, exd )
			ex.setStringF( COLID_VAT, OPIS_VAT, exd )
		 	ex.setStringF( COLID_UE, OPIS_UE, exd )
		 	ex.setStringF( COLID_USL, OPIS_USL, exd )
		 	if COLID_RECID then ex.setStringF( COLID_RECID, "Rec Id", exd )
		 	if COLID_DANEOKNA then ex.setStringF( COLID_DANEOKNA, "Dane Okna", exd )
		 	ex.setStringF(  COLID_KH_ULICA, "Ulica", exd )
		 	ex.setStringF(  COLID_KH_NUMER, "Numer", exd )
		 	ex.setStringF(  COLID_KH_KOD, "Kod pocztowy", exd )
		 	ex.setStringF(  COLID_KH_MIEJSCOWOSC, "Miejscowo", exd )

		endif

		buf = DaneOkna( recNo )
		ParsowanieDanychOkna()

		if recNo % 2 then
			exdPrep( EXST_DATAODD )
		else
			exdPrep( EXST_DATAEVEN )
		endif
		ex.newRow()
		ex.setStringF( COLID_NAZWAREJ, defrejId2Nazwa( danaDef ), exd )
		ex.setStringF( COLID_ZNACZNIK, danaZnacznik, exd )
		ex.setStringF( COLID_BUFOR, danaBufor, exd )
		ex.setStringF( COLID_OKRES, danaOkres, exd )
		ex.setDateF( COLID_DATADOK, danaDataDok, exd )
		ex.setDateF( COLID_DATAZAK, danaData, exd )
		if COLID_ABC then ex.setStringF( COLID_ABC, danaABC, exd )
		ex.setStringF( COLID_NREWID, danaNrEwid, exd )
		ex.setStringF( COLID_NRDOK, danaNrDok, exd )
		ex.setStringF( COLID_TRESC, danaTresc, exd )
		ex.setStringF( COLID_KTH, danaKth, exd )
		ex.setStringF( COLID_NIP, danaNIP, exd )
		ex.setStringF( COLID_STAWKA, danaStawka, exd )
		ex.setAmountF( COLID_BRUTTO, val( danaKwotaBrutto ), exd )
		ex.setAmountF( COLID_NETTO, val( danaKwotaNetto ), exd )
		ex.setAmountF( COLID_VAT, val( danaKwotaVat ), exd )
		ex.setStringF( COLID_UE, danaUE, exd )
		ex.setStringF( COLID_USL, danaUsl, exd )
		if COLID_RECID then	ex.setStringF( COLID_RECID, ( using "%l", recId ), exd )
		if COLID_DANEOKNA then ex.setStringF( COLID_DANEOKNA, rexTab2Bar( daneOkna( recNo ) ), exd )

		// rekord rejestru
		n_rej = dbOpen( "RejVat", true )
		SetKey(n_rej, "id")
		SetKeySeg( n_rej, "id", recId)
		GetRec( n_rej, EQ)


		// rekord kontrahenta
		n_kh = dbOpen( "Kontrahenci", true )
		SetKey(n_kh, "id")
		SetKeySeg( n_kh, "id", GetField(n_rej,"kontrahent"))
		GetRec( n_kh, EQ)				

		 	ex.setStringF(  COLID_KH_ULICA, GetField(n_kh,"ulica"), exd )
		 	ex.setStringF(  COLID_KH_NUMER, GetField(n_kh,"numerDomu"), exd )
		 	ex.setStringF(  COLID_KH_KOD, GetField(n_kh,"kod"), exd )
		 	ex.setStringF(  COLID_KH_MIEJSCOWOSC, GetField(n_kh,"miejscowosc"), exd )

		dbClose(n_rej)
		dbClose(n_kh)

		recQ += 1
		if ! ( recQ % 100 ) then
			popup( 1, "Wyeksportowano rejestrw: " + ( using "%l", recQ ) + " z " + sRecTot + "." )
		endif
	endif
	recId = getID( NX )
wend
popup( -1, "" )

if ex.isInited() then
	ex.show()
endif

error ""
